import Vue from 'vue';
import VueResource from 'vue-resource';

import App from './App';
import { DatePicker } from 'element-ui';
import '../../../theme/index.css';

Vue.component(DatePicker.name, DatePicker);

Vue.use(VueResource);

//Vue.http.options.root = window.ajaxurl;
Vue.http.options.emulateJSON = true;

function alidsDateRangePicker(el, options, cb) {

    return new Promise(function (resolve) {

        new Vue({
            data() {
                return {
                    date : [moment(options.date[0], 'YYYY-MM-DD'), moment(options.date[1], 'YYYY-MM-DD')],
                    lifetime : options.lifetime,
                }
            },
            create(){

            },
            render(createElement) {
                let self = this;
                return (createElement(App, {
                    props: {
                        date : this.date,
                        lifetime : this.lifetime,
                    },
                    on: {
                        selectDate: function (selectDate) {
                            self.date = selectDate;
                            cb([moment(selectDate[0], 'YYYY-MM-DD').format('YYYY-MM-DD'), moment(selectDate[1], 'YYYY-MM-DD').format('YYYY-MM-DD')]);
                            resolve(selectDate);
                        },
                    }
                }))
            }
        }).$mount(el);
    })

}

window.alidsDateRangePicker = alidsDateRangePicker;
